//+------------------------------------------------------+
//|                                              MAX.mq4 |
//+------------------------------------------------------+


extern double MA1Period=4;
extern double MA2Period=100;
extern double Ma1OpenLevelPeriod=4; 
extern double X=0;
extern double Y=0;
extern double TakeProfit = 10000;
extern double Lots = 0.1; 
extern double TrailingStop = 100000;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double Ma1, Ma2,Ma1OpenLevel;
   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100){
      Print("bars less than 100");
      return(0);  
   }
   if(TakeProfit<10){
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
   }
// to simplify the coding and speed up access
// data are put into internal variables
   Ma1=iMA(NULL,0,MA1Period,0,MODE_LWMA,PRICE_CLOSE,0);
   Ma2=iMA(NULL,0,MA2Period,0,MODE_LWMA,PRICE_CLOSE,0);
   Ma1OpenLevel=iMA(NULL,0,Ma1OpenLevelPeriod,0,MODE_LWMA,PRICE_OPEN,0);
   total=OrdersTotal(); 
   if(total<1){
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots)){
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
      }
      // check for long position (BUY) possibility
      if(Ma1<=Ma2<=Ma1 &&  (Ma1-Ma1OpenLevel)==X){
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"macd sample",16384,0,Green);
         if(ticket>0){
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
         }else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(Ma1<=Ma2<=Ma1OpenLevel && (Ma1-Ma1OpenLevel)<-2 ){
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
         if(ticket>0){
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
         }else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY){   // long position is opened
            // should it be closed?
            if(Ma1<=Ma2 && Ma1OpenLevel>Ma2 ){
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
            }
            // check for trailing stop
            if(TrailingStop>0){
               if(Bid-OrderOpenPrice()>Point*TrailingStop){
                  if(OrderStopLoss()<Bid-Point*TrailingStop){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                  }
               }
            }
         }else{ // go to short position
            // should it be closed?
            if(Ma1<=Ma2 && Ma1>=Ma1OpenLevel ){
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
            }
            // check for trailing stop
            if(TrailingStop>0){  
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop)){
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
       }
     }
   return(0);
  }
// the end.